package cn.pluss.platform.controller;

import cn.pluss.platform.api.PageInfo;
import cn.pluss.platform.api.Result;
import cn.pluss.platform.api.ResultGenerator;
import cn.pluss.platform.constants.ProjectConstant;
import cn.pluss.platform.entity.WxBankCode;
import cn.pluss.platform.util.StringUtil;
import cn.pluss.platform.wxBankCode.WxBankCodeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping("/wxBankCode")
@Transactional
@Api(value = "WxBankCode控制类", tags = {"WxBankCode接口"})
public class WxBankCodeController {

    @Resource
    private WxBankCodeService wxBankCodeService;

    @GetMapping
    @ApiOperation(value = "获取全部", notes = "返回分页过后的数据", httpMethod = "GET")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "page", value = "查询页码", paramType = "query", dataType = "Integer", defaultValue = "0"),
            @ApiImplicitParam(name = "size", value = "每页数据量", paramType = "query", dataType = "Integer", defaultValue = "0")
    })
    public Result<PageInfo<WxBankCode>> list(@RequestParam(defaultValue = "1") Integer page, @RequestParam(defaultValue = "10") Integer size) {
        if (size == null || size == 0) {
            size = ProjectConstant.PAGE_SIZE;
        }
        if (page == null || page == 0) {
            page = 1;
        }
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("pageSize", size);
        map.put("offset", (page - 1) * size);
        List<WxBankCode> wxBankCodeList = wxBankCodeService.queryWxBankCodePage(map);
        Integer count = wxBankCodeService.queryWxBankCodePageCount(map);
        //返回参数
        PageInfo pager = new PageInfo<WxBankCode>(count.longValue(), (long) StringUtil.getPageCount(count, size), page.longValue(), size.longValue(), wxBankCodeList);
        return ResultGenerator.genSuccessResult(pager);
    }

    @PostMapping
    @ApiOperation(value = "添加数据", notes = "添加新的数据", httpMethod = "POST")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "WxBankCode", value = "待添加的WxBankCode实例", paramType = "body", dataType = "WxBankCode", required = true)
    })
    public Result add(@RequestBody WxBankCode wxBankCode) {
        wxBankCodeService.saveWxBankCode(wxBankCode);
        return ResultGenerator.genSuccessResult();
    }

    @DeleteMapping("/{id}")
    @ApiOperation(value = "删除数据", notes = "根据id删除数据", httpMethod = "DELETE")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "查询的id实例", paramType = "path", dataType = "Integer", required = true)
    })
    public Result delete(@PathVariable Integer id) {
        WxBankCode wxBankCode = new WxBankCode();
        wxBankCode.setId(id.intValue());
        wxBankCodeService.deleteWxBankCode(wxBankCode);
        return ResultGenerator.genSuccessResult();
    }

    @PutMapping
    @ApiOperation(value = "更新数据", notes = "根据内容更新数据", httpMethod = "PUT")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "WxBankCode", value = "更新的WxBankCode实例", paramType = "body", dataType = "WxBankCode", required = true)
    })
    public Result update(@RequestBody WxBankCode wxBankCode) {
        wxBankCodeService.updateWxBankCode(wxBankCode);
        return ResultGenerator.genSuccessResult();
    }

    @GetMapping("/{id}")
    @ApiOperation(value = "获取单个值", notes = "查看单个项目的内容", httpMethod = "GET")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "查询的id", paramType = "path", required = true, dataType = "Integer", defaultValue = "0")
    })
    public Result detail(@PathVariable Long id) {
        WxBankCode wxBankCode = new WxBankCode();
        wxBankCode.setId(id.intValue());
        wxBankCode = wxBankCodeService.queryWxBankCode(wxBankCode);
        return ResultGenerator.genSuccessResult(wxBankCode);
    }

}

